#include "stdafx.h"
#include "RS232.h"
#include <stdio.h>



;
int _lastvalue=0;

unsigned char calcBIP4( unsigned char* data ) 
{ 
	unsigned char bip8=(data[0]& 0x0f) ^ data[1] ^ data[2] ^ data[3]; 
	unsigned char bip4=((bip8 & 0xf0) >>4) ^ (bip8 & 0x0f); 
	return bip4; 
} 
 


void ITLACommand(int reg,int data,int RW,int port)
{
	unsigned char buf[4]; 
	unsigned char bip4;
	buf[0]=RW;
	buf[1]=reg;
	buf[2]= (data >> 8) & 0xff;
	buf[3]=data & 0xff;
	printf("\nITLA Send Command:");
	//printf("register %d   data   %d    RW  %d  \n",reg,data,RW);
	//printf("Bytes before checksum   %x  %x  %x  %x \n",buf[0],buf[1],buf[2],buf[3]);
	bip4=calcBIP4(buf);
	buf[0]|= (bip4<<4); 
	//printf("Bytes after checksum   %x  %x  %x  %x \n",buf[0],buf[1],buf[2],buf[3]);
	RS232SetBuffer(buf,4,port);
	RS232Send(port);
	while (!RS232IsReceived(4,port)) {;}
	RS232ReadBuffer(buf,4,port);
	//printf("Response from ITLA    %x  %x  %x  %x \n",buf[0],buf[1],buf[2],buf[3]);
	_lastvalue=(int)buf[2]*256 + (int)buf[3];
	printf("lastvalue %d \n",_lastvalue);
}

int ITLALastValue(void)
{
	return(_lastvalue);
}